; +++++++++ Customized toolbar example ++++++++++
; ++++++++++ Programmed by Luis Costa +++++++++++
; ++++++++++++++ Lisbon,Postugal ++++++++++++++++
; ++++++++++++  xandaz@hotmail.com ++++++++++++++

include \masm32\include\masm32rt.inc
;include \masm32\MasmBasic\MasmBasic.inc 
WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD

.const
IdMenuNew	= 1000			; ID menu item New
IdMenuSave	= 1001			; ID menu item Save
IdMenuCopy	= 1100			; ID menu item Copy

NMTBCUSTOMDRAW STRUCT
    nmcd                 NMCUSTOMDRAW <>
    hbrMonoDither        dd ?
    hbrLines             dd ?
    hpenLines            dd ?
    clrText              dd ?
    clrMark              dd ?
    clrTextHighlight     dd ?
    clrBtnFace           dd ?
    clrBtnHighlight      dd ?
    clrHighlightHotTrack dd ?
    rcText               RECT <>
    nStringBkMode        dd ?
    nHLStringBkMode      dd ?
    iListGap             dd ?
NMTBCUSTOMDRAW ENDS

MainWindowWidth     equ     600
MainWindowHeight    equ     350

NoButtons           equ     6
DRAW_GRIPPER        equ     0100h
WS_TOOLBAR          equ     WS_VISIBLE+WS_CHILD+TBSTYLE_CUSTOMERASE+TBSTYLE_FLAT

.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      'Customized Toolbar',0
hMenu	HWND ?
ghM3	dd ?
hEdit	dd ?

wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW+CS_DROPSHADOW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>

; ++++ Toolbar related +++++

hToolbar        dd      ?
ToolbarClass    db      'ToolbarWindow32',0
TBButtons       TBBUTTON        <0,20h,TBSTATE_ENABLED,BTNS_SEP,DRAW_GRIPPER,1>
                TBBUTTON        <0,0,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>                        
                TBBUTTON        <0,1,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
                TBBUTTON        <0,2,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
                TBBUTTON        <0,3,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
                TBBUTTON        <0,4,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
                
hMemDC      HDC     ?
hDC         HDC     ?
rect        RECT        <>
BmpHandles      dd      10 dup(?)

.code
    start:
    invoke InitCommonControls
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_VISIBLE,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC uses ebx    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
LOCAL hM1:HWND, hM2:HWND
    local   BtnSize:WORD
    local   wcx:WNDCLASSEX
    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
    .elseif uMsg==WM_CREATE
		mov hMenu, rv(CreateMenu)				; create the main menu
		mov hM1, rv(CreateMenu)				; plus three
		mov hM2, rv(CreateMenu)				; sub menus
;		mov ghM3, rv(CreateMenu)
		invoke AppendMenu, hMenu, MF_POPUP	, hM1, chr$("&File")
		invoke AppendMenu, hM1, MF_STRING, IdMenuNew, chr$("&New",9,"Ctrl+N")
		invoke AppendMenu, hM1, MF_STRING, IdMenuSave, chr$("&Save",9,"Ctrl+S")
		invoke AppendMenu, hMenu, MF_POPUP, hM2, chr$("&Edit")
		invoke AppendMenu, hM2, MF_STRING, IdMenuCopy, chr$("&Copy",9,"Ctrl+C")
		invoke SetMenu, hWnd, hMenu			; attach menu to main window
        mov     edi,lParam
        .if     [edi.CREATESTRUCT].hWndParent==NULL

            invoke  CreateWindowEx,NULL,addr ToolbarClass,NULL,WS_TOOLBAR OR CCS_NOMOVEY,\
                    0,50,0,0,hWnd,0100h,hInstance,NULL
            mov     hToolbar,eax
            invoke  SendMessage,hToolbar,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,NULL
            invoke  SendMessage,hToolbar,TB_ADDBUTTONS,NoButtons,addr TBButtons
            invoke  SendMessage,hToolbar,TB_SETBUTTONSIZE,NULL,200020h
            invoke  SendMessage,hToolbar,TB_AUTOSIZE,NULL,NULL
		IdEdit	= 2000
		invoke CreateWindowEx, WS_EX_CLIENTEDGE, chr$("edit"), NULL, 
			WS_CHILD or WS_VISIBLE or WS_BORDER	or ES_LEFT or ES_AUTOHSCROLL or ES_MULTILINE,
			0, 0, 100, 24,
			hWnd, IdEdit, hInstance, NULL
		mov hEdit, eax							; we have created an edit window
            mov     esi,0100
            lea     edi,BmpHandles
            mov     ecx,15
            cld
bmp_loop:
            push    ecx
            invoke  LoadBitmap,hInstance,esi
            stosd
            pop     ecx
            dec     ecx
            jcxz    end_bmp_loop
            inc     esi
            jmp     bmp_loop
end_bmp_loop:            
            
        .endif    
    .elseif uMsg==WM_NOTIFY
        mov     edi,lParam
        .if     [edi.NMTBCUSTOMDRAW].nmcd.hdr.code==NM_CUSTOMDRAW
           .if      [edi.NMTBCUSTOMDRAW].nmcd.dwDrawStage==CDDS_PREPAINT
                mov     eax,CDRF_NOTIFYITEMDRAW+TBCDRF_NOBACKGROUND
                ret
            .elseif [edi.NMTBCUSTOMDRAW].nmcd.dwDrawStage==CDDS_ITEMPREPAINT
                invoke  CreateCompatibleDC,[edi.NMTBCUSTOMDRAW].nmcd.hdc
                mov     hMemDC,eax
                mov     eax,[edi.NMTBCUSTOMDRAW].nmcd.dwItemSpec
                shl     eax,3
                lea     esi,BmpHandles
                add     esi,eax
                test    [edi.NMTBCUSTOMDRAW].nmcd.uItemState,CDIS_SELECTED
                jz      unselected
                add     esi,4
                invoke  SelectObject,hMemDC,dword ptr [esi]
                jmp     draw
unselected:               
                invoke  SelectObject,hMemDC,dword ptr [esi]
draw:
                lea     esi,[edi.NMTBCUSTOMDRAW].nmcd.rc
                assume  esi:PTR RECT
                invoke  StretchBlt,[edi.NMTBCUSTOMDRAW].nmcd.hdc,[edi.NMTBCUSTOMDRAW].nmcd.rc.left\
                ,[edi.NMTBCUSTOMDRAW].nmcd.rc.top,[edi.NMTBCUSTOMDRAW].nmcd.rc.right\
                ,[edi.NMTBCUSTOMDRAW].nmcd.rc.bottom,hMemDC,0,0,[esi].right,[esi].bottom,SRCCOPY
end_draw:                
                invoke  DeleteDC,hMemDC
                mov     eax,CDRF_SKIPDEFAULT
                ret                               
                                            
            .endif
        .endif                                               
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

end start                                            

    .if uMsg==WM_MEASUREITEM
    	mov ebx, lParam
    	mov [ebx.MEASUREITEMSTRUCT.CtlType], ODT_MENU
    	mov [ebx.MEASUREITEMSTRUCT.itemHeight], 30
    	mov [ebx.MEASUREITEMSTRUCT.itemWidth], 32767
    	xor eax, eax
    	inc eax
    	ret
;    	deb 1, "Gotcha", eax
    .endif
OPT_Tmp2asm	1
